/* PWM registers configuration
 * Fosc = 614000 Hz
 * Fpwm = 49.97 Hz (Requested : 50 Hz)
 * Duty Cycle = 5 %
 * Resolution is 10 bits
 * Prescaler is 16
 * Ensure that your PWM pin is configured as digital output
 * see more details on http://www.micro-examples.com/  */
#include <htc.h>
 
void pwm_init(void) {

	TRISC2 = 0;	// rc2 = pwm1 as output
	TRISC1 = 0;	// rc1 = pwm2 as output
	PR2 = 0xC0 ;	// repition rate (t2)
	T2CON = 0x06 ;	// t2 enable & ps=16

}

void pwm_dc(unsigned char port, unsigned char dc ){
// set duty cycle using lsb's
	unsigned char upper, lower;
	lower = (dc & 0x03) << 4;
	upper = dc >> 2;
	if ( port == 1 ){
	CCPR1L = upper;
	CCP1CON = 0x0C | lower;}
	else {
	CCPR2L = upper;
	CCP2CON = 0x0C | lower;}
}
	

