/* Serial communications using the on-board hardware USART
 * of the Microchip PIC16F876 series of devices. */
// BAUD 9600     
// xtal osc 4.9152 Mhz divided by 8
// FOSC 614400 - 614 Khz
#include <htc.h>

void uart_init(void) {
// setup serial port
	TRISC7 = 1;	// rc7 is rx
	TRISC6 = 0;	// rc6 is tx	  
	SPBRG = 0x03;	// serial port rate
	RCSTA = 0x90;	// spen & cren (serial port & continuous recieve)
	TXSTA = (0x20|0x4);	// txen & brgh = hi-speed (xmit enable)
}

void putch(unsigned char byte) {
/* output one byte */
	while(!TXIF)	/* set when register is empty */
		continue;
	TXREG = byte;
}

unsigned char getch() {
/* retrieve one byte */
	while(!RCIF)	/* set when register is not empty */
		continue;
	return RCREG;	
}

void puts(char *s) {
/* output string */
	while(*s != 0)
	{
		putch(*s++);
	}
}

unsigned char getche(void) {
/* get byte and echo */
	unsigned char c;
	putch(c = getch());
	return c;
}

void put3digits(unsigned char num) {
/* output num as 3 digits */
	unsigned char c;
	if (c=num/100)
		putch('0'+c);
	if (c=(num%100)/10)
		putch('0'+c);
	putch('0'+num%10);
	return;
}

